Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# GeomPrimitive Class Reference

This is an abstract base class for a family of classes that represent the fundamental geometry primitives that may be stored in a Geom. More...

Inheritance diagram for GeomPrimitive:

List of all members.

## Public Member Functions
| addConsecutiveVertices (int start, int num_vertices)
| Adds a consecutive sequence of vertices, beginning at start, to the primitive.
| addNextVertices (int num_vertices)
| Adds the next n vertices in sequence, beginning from the last vertex added to the primitive + 1.
| addVertex (int vertex)
| Adds the indicated vertex to the list of vertex indices used by the graphics primitive type.
| addVertices (int v1, int v2, int v3)
| Adds several vertices in a row.
| addVertices (int v1, int v2, int v3, int v4)
| Adds several vertices in a row.
| addVertices (int v1, int v2)
| Adds several vertices in a row.
bool | checkValid (GeomVertexData const vertex_data)
| Verifies that the primitive only references vertices that actually exist within the indicated GeomVertexData.
| clearMinmax ()
| Undoes a previous call to set_minmax(), and allows the minimum and maximum values to be recomputed normally.
| clearVertices ()
| Removes all of the vertices and primitives from the object, so they can be re-added.
bool | closePrimitive ()
| Indicates that the previous n calls to add_vertex(), since the last call to close_primitive(), have fully defined a new primitive.
GeomPrimitive const | decompose ()
| Decomposes a complex primitive type into a simpler primitive type, for instance triangle strips to triangles, and returns a pointer to the new primitive definition.
GeomPrimitive const | doubleside ()
| Duplicates triangles in the primitive so that each triangle is back-to-back with another triangle facing in the opposite direction.
int | getDataSizeBytes ()
| Returns the number of bytes stored in the vertices array.
ConstPointerToArrayint | getEnds ()
| Returns a const pointer to the primitive ends array so application code can read it directly.
int | getFirstVertex ()
| Returns the first vertex number referenced by the primitive.
int | getGeomRendering ()
| Returns the set of GeomRendering bits that represent the rendering properties required to properly render this primitive.
int | getIndexStride ()
| A convenience function to return the gap between successive index numbers, in bytes, of the index data.
NumericType | getIndexType ()
| Returns the numeric type of the index column.
GeomVertexArrayData const | getMaxs ()
| Returns a const pointer to the primitive maxs array so application code can read it directly.
int | getMaxVertex ()
| Returns the maximum vertex index number used by all the primitives in this object.
int | getMinNumVerticesPerPrimitive ()
| Returns the minimum number of vertices that must be added before close_primitive() may legally be called.
GeomVertexArrayData const | getMins ()
| Returns a const pointer to the primitive mins array so application code can read it directly.
int | getMinVertex ()
| Returns the minimum vertex index number used by all the primitives in this object.
UpdateSeq | getModified ()
| Returns a sequence number which is guaranteed to change at least every time the vertex index array is modified.
int | getNumBytes ()
| Returns the number of bytes consumed by the primitive and its index table(s).
int | getNumFaces ()
| Returns the number of triangles or other fundamental type (such as line segments) represented by all the primitives in this object.
int | getNumPrimitives ()
| Returns the number of individual primitives stored within this object.
int | getNumUnusedVerticesPerPrimitive ()
| Returns the number of vertices that are added between primitives that aren't, strictly speaking, part of the primitives themselves.
int | getNumVertices ()
| Returns the number of vertices used by all the primitives in this object.
int | getNumVerticesPerPrimitive ()
| If the primitive type is a simple type in which all primitives have the same number of vertices, like triangles, returns the number of vertices per primitive.
int | getPrimitiveEnd (int n)
| Returns the element within the _vertices list at which the nth primitive ends.
int | getPrimitiveMaxVertex (int n)
| Returns the maximum vertex index number used by the nth primitive in this object.
int | getPrimitiveMinVertex (int n)
| Returns the minimum vertex index number used by the nth primitive in this object.
int | getPrimitiveNumFaces (int n)
| Returns the number of triangles or other fundamental type (such as line segments) represented by the nth primitive in this object.
int | getPrimitiveNumVertices (int n)
| Returns the number of vertices used by the nth primitive.
int | getPrimitiveStart (int n)
| Returns the element within the _vertices list at which the nth primitive starts.
PrimitiveType | getPrimitiveType ()
ShadeModel | getShadeModel ()
| Returns the ShadeModel hint for this primitive.
UsageHint | getUsageHint ()
| Returns the usage hint for this primitive.
int | getVertex (int i)
| Returns the ith vertex index in the table.
list | getVertices ()
GeomVertexArrayData const | getVertices ()
| Returns a const pointer to the vertex index array so application code can read it directly.
bool | isComposite ()
| Returns true if the primitive is a composite primitive such as a tristrip or trifan, or false if it is a fundamental primitive such as a collection of triangles.
bool | isIndexed ()
| Returns true if the primitive is indexed, false otherwise.
GeomPrimitive | makeCopy ()
| makeIndexed ()
| Converts the primitive from nonindexed form to indexed form.
| makeNonindexed (GeomVertexData dest, GeomVertexData const source)
| Converts the primitive from indexed to nonindexed by duplicating vertices as necessary into the indicated dest GeomVertexData.
GeomPrimitive const | makePoints ()
| Returns a new GeomPoints primitive that represents each of the vertices in the original primitive, rendered exactly once.
GeomPrimitive const | matchShadeModel (ShadeModel shade_model)
| Returns a new primitive that is compatible with the indicated shade model, if possible, or NULL if this is not possible.
PointerToArrayint | modifyEnds ()
| Returns a modifiable pointer to the primitive ends array, so application code can directly fiddle with this data.
GeomVertexArrayData | modifyVertices (int num_vertices)
| Returns a modifiable pointer to the vertex index list, so application code can directly fiddle with this data.
GeomVertexArrayData | modifyVertices ()
| Returns a modifiable pointer to the vertex index list, so application code can directly fiddle with this data.
| offsetVertices (int offset)
| Adds the indicated offset to all vertices used by the primitive.
| operator new (unsigned int size)
GeomPrimitive | operator= (GeomPrimitive const copy)
| The copy assignment operator is not pipeline-safe.
| output (ostream out)
| packVertices (GeomVertexData dest, GeomVertexData const source)
| Packs the vertices used by the primitive from the indicated source array onto the end of the indicated destination array.
bool | requestResident ()
| Returns true if the primitive data is currently resident in memory.
| reserveNumVertices (int num_vertices)
| This ensures that enough memory space for n vertices is allocated, so that you may increase the number of vertices to n without causing a new memory allocation.
GeomPrimitive const | reverse ()
| Reverses the winding order in the primitive so that each triangle is facing in the opposite direction it was originally.
GeomPrimitive const | rotate ()
| Returns a new primitive with the shade_model reversed (if it is flat shaded), if possible.
| setEnds (ConstPointerToArrayint ends)
| Completely replaces the primitive ends array with a new table.
| setIndexType (NumericType index_type)
| Changes the numeric type of the index column.
| setMinmax (int min_vertex, int max_vertex, GeomVertexArrayData mins, GeomVertexArrayData maxs)
| Explicitly specifies the minimum and maximum vertices, as well as the lists of per-component min and max.
| setNonindexedVertices (int first_vertex, int num_vertices)
| Sets the primitive up as a nonindexed primitive, using the indicated vertex range.
| setShadeModel (ShadeModel shade_model)
| Changes the ShadeModel hint for this primitive.
| setUsageHint (UsageHint usage_hint)
| Changes the UsageHint hint for this primitive.
| setVertices (GeomVertexArrayData const vertices)
| Completely replaces the vertex index list with a new table.
| setVertices (GeomVertexArrayData const vertices, int num_vertices)
| Completely replaces the vertex index list with a new table.
| write (ostream out, int indent_level)
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

This is an abstract base class for a family of classes that represent the fundamental geometry primitives that may be stored in a Geom.

They all have in common the fact that they are defined by tables of vertex data stored in a GeomVertexData object. Each GeomPrimitive object contains an ordered list of integers, which index into the vertex array defined by the GeomVertexData and define the particular vertices of the GeomVertexData that are used for this primitive.

The meaning of a given arrangement of vertices is defined by each individual primitive type; for instance, a GeomTriangle renders a triangle from each three consecutive vertices, while a GeomTriangleStrip renders a strip of (n - 2) connected triangles from each sequence of n vertices.

## Member Function Documentation

addConsecutiveVertices | ( | int | start,
|  | int | num_vertices
| ) |  |

Adds a consecutive sequence of vertices, beginning at start, to the primitive.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

addNextVertices | ( | int | num_vertices | ) |

Adds the next n vertices in sequence, beginning from the last vertex added to the primitive + 1.

This is most useful when you are building up a primitive and a GeomVertexData at the same time, and you just want the primitive to reference the first n vertices from the data, then the next n, and so on.

addVertex | ( | int | vertex | ) |

Adds the indicated vertex to the list of vertex indices used by the graphics primitive type.

To define a primitive, you must call add_vertex() for each vertex of the new primitive, and then call close_primitive() after you have specified the last vertex of each primitive.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

addVertices | ( | int | v1,
|  | int | v2,
|  | int | v3
| ) |  |

Adds several vertices in a row.

addVertices | ( | int | v1,
|  | int | v2,
|  | int | v3,
|  | int | v4
| ) |  |

Adds several vertices in a row.

addVertices | ( | int | v1,
|  | int | v2
| ) |  |

Adds several vertices in a row.

bool checkValid | ( | GeomVertexData const | vertex_data | ) |

Verifies that the primitive only references vertices that actually exist within the indicated GeomVertexData.

Returns true if the primitive appears to be valid, false otherwise.

clearMinmax | ( |  | ) |

Undoes a previous call to set_minmax(), and allows the minimum and maximum values to be recomputed normally.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

clearVertices | ( |  | ) |

Removes all of the vertices and primitives from the object, so they can be re-added.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

bool closePrimitive | ( |  | ) |

Indicates that the previous n calls to add_vertex(), since the last call to close_primitive(), have fully defined a new primitive.

Returns true if successful, false otherwise.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

GeomPrimitive const decompose | ( |  | ) |

Decomposes a complex primitive type into a simpler primitive type, for instance triangle strips to triangles, and returns a pointer to the new primitive definition.

If the decomposition cannot be performed, this might return the original object.

This method is useful for application code that wants to iterate through the set of triangles on the primitive without having to write handlers for each possible kind of primitive type.

GeomPrimitive const doubleside | ( |  | ) |

Duplicates triangles in the primitive so that each triangle is back-to-back with another triangle facing in the opposite direction.

Note that this doesn't affect vertex normals, so this operation alone won't work in the presence of lighting (but see SceneGraphReducer.doubleside()).

Also see CullFaceAttrib, which can enable rendering of both sides of a triangle without having to duplicate it (but which doesn't necessarily work in the presence of lighting).

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from CopyOnWriteObject.

Reimplemented in GeomLines, GeomLinestrips, GeomPoints, GeomTriangles, GeomTrifans, and GeomTristrips.

int getDataSizeBytes | ( |  | ) |

Returns the number of bytes stored in the vertices array.

ConstPointerToArrayint getEnds | ( |  | ) |

Returns a const pointer to the primitive ends array so application code can read it directly.

Do not attempt to modify the returned array; use modify_ends() or set_ends() for this.

Note that simple primitive types, like triangles, do not have a ends array: since all the primitives have the same number of vertices, it is not needed.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

int getFirstVertex | ( |  | ) |

Returns the first vertex number referenced by the primitive.

This is particularly important in the case of a nonindexed primitive, in which case get_first_vertex() and get_num_vertices() completely define the extent of the vertex range.

int getGeomRendering | ( |  | ) |

Returns the set of GeomRendering bits that represent the rendering properties required to properly render this primitive.

int getIndexStride | ( |  | ) |

A convenience function to return the gap between successive index numbers, in bytes, of the index data.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

NumericType getIndexType | ( |  | ) |

Returns the numeric type of the index column.

Normally, this will be either NT_uint16 or NT_uint32.

GeomVertexArrayData const getMaxs | ( |  | ) |

Returns a const pointer to the primitive maxs array so application code can read it directly.

Do not attempt to modify the returned array; use set_minmax().

Note that simple primitive types, like triangles, do not have a maxs array.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

int getMaxVertex | ( |  | ) |

Returns the maximum vertex index number used by all the primitives in this object.

int getMinNumVerticesPerPrimitive | ( |  | ) |

Returns the minimum number of vertices that must be added before close_primitive() may legally be called.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

GeomVertexArrayData const getMins | ( |  | ) |

Returns a const pointer to the primitive mins array so application code can read it directly.

Do not attempt to modify the returned array; use set_minmax() for this.

Note that simple primitive types, like triangles, do not have a mins array.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

int getMinVertex | ( |  | ) |

Returns the minimum vertex index number used by all the primitives in this object.

UpdateSeq getModified | ( |  | ) |

Returns a sequence number which is guaranteed to change at least every time the vertex index array is modified.

int getNumBytes | ( |  | ) |

Returns the number of bytes consumed by the primitive and its index table(s).

int getNumFaces | ( |  | ) |

Returns the number of triangles or other fundamental type (such as line segments) represented by all the primitives in this object.

int getNumPrimitives | ( |  | ) |

Returns the number of individual primitives stored within this object.

All primitives are the same type.

int getNumUnusedVerticesPerPrimitive | ( |  | ) |

Returns the number of vertices that are added between primitives that aren't, strictly speaking, part of the primitives themselves.

This is used, for instance, to define degenerate triangles to connect otherwise disconnected triangle strips.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

int getNumVertices | ( |  | ) |

Returns the number of vertices used by all the primitives in this object.

int getNumVerticesPerPrimitive | ( |  | ) |

If the primitive type is a simple type in which all primitives have the same number of vertices, like triangles, returns the number of vertices per primitive.

If the primitive type is a more complex type in which different primitives might have different numbers of vertices, for instance a triangle strip, returns 0.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

int getPrimitiveEnd | ( | int | n | ) |

Returns the element within the _vertices list at which the nth primitive ends.

This is one past the last valid element for the nth primitive.

int getPrimitiveMaxVertex | ( | int | n | ) |

Returns the maximum vertex index number used by the nth primitive in this object.

int getPrimitiveMinVertex | ( | int | n | ) |

Returns the minimum vertex index number used by the nth primitive in this object.

int getPrimitiveNumFaces | ( | int | n | ) |

Returns the number of triangles or other fundamental type (such as line segments) represented by the nth primitive in this object.

int getPrimitiveNumVertices | ( | int | n | ) |

Returns the number of vertices used by the nth primitive.

This is the same thing as get_primitive_end(n) - get_primitive_start(n).

int getPrimitiveStart | ( | int | n | ) |

Returns the element within the _vertices list at which the nth primitive starts.

If i is one more than the highest valid primitive vertex, the return value will be one more than the last valid vertex. Thus, it is generally true that the vertices used by a particular primitive i are the set get_primitive_start(n) <= vi < get_primitive_start(n + 1) (although this range also includes the unused vertices between primitives).

PrimitiveType getPrimitiveType | ( |  | ) |

ShadeModel getShadeModel | ( |  | ) |

Returns the ShadeModel hint for this primitive.

This is intended as a hint to the renderer to tell it how the per-vertex colors and normals are applied.

UsageHint getUsageHint | ( |  | ) |

Returns the usage hint for this primitive.

See geomEnums.h. This has nothing to do with the usage hint associated with the primitive's vertices; this only specifies how often the vertex indices that define the primitive will be modified.

It is perfectly legal (and, in fact, common) for a GeomPrimitive to have UH_static on itself, while referencing vertex data with UH_dynamic. This means that the vertices themselves will be animated, but the primitive will always reference the same set of vertices from the pool.

int getVertex | ( | int | i | ) |

Returns the ith vertex index in the table.

list getVertices | ( |  | ) |

GeomVertexArrayData const getVertices | ( |  | ) |

Returns a const pointer to the vertex index array so application code can read it directly.

This might return NULL if the primitive is nonindexed. Do not attempt to modify the returned array; use modify_vertices() or set_vertices() for this.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

bool isComposite | ( |  | ) |

Returns true if the primitive is a composite primitive such as a tristrip or trifan, or false if it is a fundamental primitive such as a collection of triangles.

bool isIndexed | ( |  | ) |

Returns true if the primitive is indexed, false otherwise.

An indexed primitive stores a table of index numbers into its GeomVertexData, so that it can reference the vertices in any order. A nonindexed primitive, on the other hand, stores only the first vertex number and number of vertices used, so that it can only reference the vertices consecutively.

GeomPrimitive makeCopy | ( |  | ) |

makeIndexed | ( |  | ) |

Converts the primitive from nonindexed form to indexed form.

This will simply create an index table that is numbered consecutively from get_first_vertex(); it does not automatically collapse together identical vertices that may have been split apart by a previous call to make_nonindexed().

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

makeNonindexed | ( | GeomVertexData | dest,
|  | GeomVertexData const | source
| ) |  |

Converts the primitive from indexed to nonindexed by duplicating vertices as necessary into the indicated dest GeomVertexData.

GeomPrimitive const makePoints | ( |  | ) |

Returns a new GeomPoints primitive that represents each of the vertices in the original primitive, rendered exactly once.

If the original primitive is already a GeomPoints primitive, returns the original primitive unchanged.

GeomPrimitive const matchShadeModel | ( | ShadeModel | shade_model | ) |

Returns a new primitive that is compatible with the indicated shade model, if possible, or NULL if this is not possible.

In most cases, this will return either NULL or the original primitive. In the case of a SM_flat_first_vertex vs. a SM_flat_last_vertex (or vice-versa), however, it will return a rotated primitive.

PointerToArrayint modifyEnds | ( |  | ) |

Returns a modifiable pointer to the primitive ends array, so application code can directly fiddle with this data.

Use with caution, since there are no checks that the data will be left in a stable state.

Note that simple primitive types, like triangles, do not have a ends array: since all the primitives have the same number of vertices, it is not needed.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

GeomVertexArrayData modifyVertices | ( | int | num_vertices | ) |

Returns a modifiable pointer to the vertex index list, so application code can directly fiddle with this data.

Use with caution, since there are no checks that the data will be left in a stable state.

If this is called on a nonindexed primitive, it will implicitly be converted to an indexed primitive.

If num_vertices is not -1, it specifies an artificial limit to the number of vertices in the array. Otherwise, all of the vertices in the array will be used.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

GeomVertexArrayData modifyVertices | ( |  | ) |

Returns a modifiable pointer to the vertex index list, so application code can directly fiddle with this data.

Use with caution, since there are no checks that the data will be left in a stable state.

If this is called on a nonindexed primitive, it will implicitly be converted to an indexed primitive.

If num_vertices is not -1, it specifies an artificial limit to the number of vertices in the array. Otherwise, all of the vertices in the array will be used.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

offsetVertices | ( | int | offset | ) |

Adds the indicated offset to all vertices used by the primitive.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

operator new | ( | unsigned int | size | ) |

GeomPrimitive operator= | ( | GeomPrimitive const | copy | ) |

The copy assignment operator is not pipeline-safe.

This will completely obliterate all stages of the pipeline, so don't do it for a GeomPrimitive that is actively being used for rendering.

output | ( | ostream | out | ) |

packVertices | ( | GeomVertexData | dest,
|  | GeomVertexData const | source
| ) |  |

Packs the vertices used by the primitive from the indicated source array onto the end of the indicated destination array.

bool requestResident | ( |  | ) |

Returns true if the primitive data is currently resident in memory.

If this returns false, the primitive data will be brought back into memory shortly; try again later.

reserveNumVertices | ( | int | num_vertices | ) |

This ensures that enough memory space for n vertices is allocated, so that you may increase the number of vertices to n without causing a new memory allocation.

This is a performance optimization only; it is especially useful when you know ahead of time that you will be adding n vertices to the primitive.

Note that the total you specify here should also include implicit vertices which may be added at each close_primitive() call, according to get_num_unused_vertices_per_primitive().

Note also that making this call will implicitly make the primitive indexed if it is not already, which could result in a performance *penalty*. If you would prefer not to lose the nonindexed nature of your existing GeomPrimitives, check is_indexed() before making this call.

GeomPrimitive const reverse | ( |  | ) |

Reverses the winding order in the primitive so that each triangle is facing in the opposite direction it was originally.

Note that this doesn't affect vertex normals, so this operation alone won't work in the presence of lighting (but see SceneGraphReducer.reverse()).

Also see CullFaceAttrib, which can change the visible direction of a triangle without having to duplicate it (but which doesn't necessarily work in the presence of lighting).

GeomPrimitive const rotate | ( |  | ) |

Returns a new primitive with the shade_model reversed (if it is flat shaded), if possible.

If the primitive type cannot be rotated, returns the original primitive, unrotated.

If the current shade_model indicates flat_vertex_last, this should bring the last vertex to the first position; if it indicates flat_vertex_first, this should bring the first vertex to the last position.

setEnds | ( | ConstPointerToArrayint | ends | ) |

Completely replaces the primitive ends array with a new table.

Chances are good that you should also replace the vertices list with set_vertices() at the same time.

Note that simple primitive types, like triangles, do not have a ends array: since all the primitives have the same number of vertices, it is not needed.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

setIndexType | ( | NumericType | index_type | ) |

Changes the numeric type of the index column.

Normally, this should be either NT_uint16 or NT_uint32.

The index type must be large enough to include all of the index values in the primitive. It may be automatically elevated, if necessary, to a larger index type, by a subsequent call to add_index() that names an index value that does not fit in the index type you specify.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

setMinmax | ( | int | min_vertex,
|  | int | max_vertex,
|  | GeomVertexArrayData | mins,
|  | GeomVertexArrayData | maxs
| ) |  |

Explicitly specifies the minimum and maximum vertices, as well as the lists of per-component min and max.

Use this method with extreme caution. It's generally better to let the GeomPrimitive compute these explicitly, unless for some reason you can do it faster and you absolutely need the speed improvement.

Note that any modification to the vertex array will normally cause this to be recomputed, unless you set it immediately again.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

setNonindexedVertices | ( | int | first_vertex,
|  | int | num_vertices
| ) |  |

Sets the primitive up as a nonindexed primitive, using the indicated vertex range.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

setShadeModel | ( | ShadeModel | shade_model | ) |

Changes the ShadeModel hint for this primitive.

This is different from the ShadeModelAttrib that might also be applied from the scene graph. This does not affect the shade model that is in effect when rendering, but rather serves as a hint to the renderer to tell it how the per-vertex colors and normals on this primitive are applied.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

setUsageHint | ( | UsageHint | usage_hint | ) |

Changes the UsageHint hint for this primitive.

See get_usage_hint().

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

setVertices | ( | GeomVertexArrayData const | vertices | ) |

Completely replaces the vertex index list with a new table.

Chances are good that you should also replace the ends list with set_ends() at the same time.

If num_vertices is not -1, it specifies an artificial limit to the number of vertices in the array. Otherwise, all of the vertices in the array will be used.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

setVertices | ( | GeomVertexArrayData const | vertices,
|  | int | num_vertices
| ) |  |

Completely replaces the vertex index list with a new table.

Chances are good that you should also replace the ends list with set_ends() at the same time.

If num_vertices is not -1, it specifies an artificial limit to the number of vertices in the array. Otherwise, all of the vertices in the array will be used.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

This method is intended for low-level usage only. There are higher-level methods for more common usage. We recommend you do not use this method directly. If you do, be sure you know what you are doing!

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties